diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/ddtUEqn.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/ddtUEqn.H
new file mode 100644
index 000000000..e9cfd2abb
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/ddtUEqn.H
@@ -0,0 +1,47 @@
+forAll(phases, phasei)
+{
+    phaseModel& phase = phases[phasei];
+    const volScalarField& alpha = phase;
+    const volScalarField& rhoAlpha = phase.rho();
+    volVectorField& UAlpha = phase.URef();
+
+    ddtUEqns.set
+    (
+        phasei,
+        fvm::ddt(alpha, rhoAlpha, UAlpha)
+      - fvm::Sp(fvc::ddt(alpha, rhoAlpha), UAlpha)
+    );
+
+    word ddtScheme
+    (
+        mesh.ddtScheme
+        (
+            "ddt("
+          + alpha.name()
+          + ',' + rhoAlpha.name() + ','
+          + UAlpha.name() + ')'
+        ).last().wordToken()
+    );
+
+    if (ddtScheme == "Euler")
+    {
+        ddtPhiCoeffs.set
+        (
+            phasei,
+            (
+                byDt
+                (
+                    fvc::interpolate(alpha.oldTime())
+                   *fvc::interpolate(rhoAlpha.oldTime())
+                   *phase.phiRef().oldTime()
+                )
+            )
+        );
+    }
+    else
+    {
+        FatalErrorInFunction
+            << "Only Euler is an allowed time scheme "
+            << "for this solver." << exit(FatalError);
+    }
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragDiag.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragDiag.H
new file mode 100644
index 000000000..2f564e07c
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragDiag.H
@@ -0,0 +1,65 @@
+initZeroPtrList(dragDiag, mesh, dimensionSet(1, -3, -1, 0, 0), "dragDiag");
+initZeroPtrList(dragDiagf, mesh, dimensionSet(1, -3, -1, 0, 0), "dragDiagf");
+initZeroPtrList(dragPCoefff, mesh, dimensionSet(0, 0, 0, 0, 0), "dragPCoefff");
+
+forAllConstIter(multiphaseSystem::KdTable, fluid.Kds(), KdIter)
+{
+    const volScalarField& K(*KdIter());
+    const phasePair& pair(fluid.phasePairs()[KdIter.key()]);
+
+    forAllConstIter(phasePair, pair, iter)
+    {
+        const phaseModel& phase = iter();
+        const phaseModel& otherPhase = iter.otherPhase();
+
+        if (partialElimination)
+        {
+            dragDiag[phase.index()] +=
+                K
+               *(
+                    1
+                  + rAs[otherPhase.index()]
+                   *(
+                        HUEqns[phase.index()].A()
+                      + ddtUEqns[phase.index()].A()
+                    )
+                );
+        }
+        else
+        {
+            dragDiag[phase.index()] += K;
+        }
+    }
+}
+
+forAllConstIter(multiphaseSystem::KdfTable, fluid.Kdfs(), KdfIter)
+{
+    const surfaceScalarField& Kf(*KdfIter());
+    const phasePair& pair(fluid.phasePairs()[KdfIter.key()]);
+
+    forAllConstIter(phasePair, pair, iter)
+    {
+        const phaseModel& phase = iter();
+        const phaseModel& otherPhase = iter.otherPhase();
+
+        if (partialElimination)
+        {
+            dragDiagf[phase.index()] +=
+                Kf
+               *(
+                    1
+                  + rAfs[otherPhase.index()]
+                   *(
+                        fvc::interpolate(HUEqns[phase.index()].A())
+                      + fvc::interpolate(ddtUEqns[phase.index()].A())
+                    )
+                );
+
+            dragPCoefff[phase.index()] += Kf*rAfs[otherPhase.index()];
+        }
+        else
+        {
+            dragDiagf[phase.index()] += Kf;
+        }
+    }
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragSource.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragSource.H
new file mode 100644
index 000000000..4ffda234e
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragSource.H
@@ -0,0 +1,68 @@
+// Summed RHS of cell-based momentum balance equation
+volVectorField HSum
+(
+    IOobject
+    (
+        "HSum",
+        runTime.timeName(),
+        mesh
+    ),
+    mesh,
+    dimensionedVector(dimensionSet(1, -2, -2, 0, 0), Zero)
+);
+
+if (partialElimination)
+{
+    forAll(phases, phasei)
+    {
+        HSum +=
+            HUEqns[phasei].H()
+          + ddtUEqns[phasei].H();
+    }
+}
+
+initZeroPtrList
+(
+    dragSource, mesh, dimensionSet(1, -2, -2, 0, 0), "dragSource"
+);
+
+
+forAllConstIter(multiphaseSystem::KdTable, fluid.Kds(), KdIter)
+{
+    const volScalarField& K(*KdIter());
+    const phasePair& pair(fluid.phasePairs()[KdIter.key()]);
+
+    forAllConstIter(phasePair, pair, iter)
+    {
+        const phaseModel& phase = iter();
+        const phaseModel& otherPhase = iter.otherPhase();
+
+        if (partialElimination)
+        {
+            dragSource[phase.index()] += K*rAs[otherPhase.index()]*HSum;
+
+            forAll(phases, phasei)
+            {
+                if
+                (
+                    (phasei == phase.index())
+                 || (phasei == otherPhase.index())
+                ) continue;
+
+                dragSource[phase.index()] -=
+                (
+                    K*rAs[otherPhase.index()]
+                   *(
+                        HUEqns[phasei].A()
+                      + ddtUEqns[phasei].A()
+                    )
+                   *phases[phasei].U()
+                );
+            }
+        }
+        else
+        {
+            dragSource[phase.index()] += K*phases[otherPhase.index()].U();
+        }
+    }
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragSourcef.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragSourcef.H
new file mode 100644
index 000000000..7691b08f4
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/dragSourcef.H
@@ -0,0 +1,61 @@
+// Summed RHS of face-based momentum balance equation
+if (partialElimination)
+{
+    initZeroPtrList(HbyASumf, mesh, dimensionSet(0, 3, -1, 0, 0), "HbyASumf");
+    forAll(phases, phasei)
+    {
+        forAll(phases, phasej)
+        {
+            HbyASumf[phasei] +=
+                rHUfs[phasei]
+               *(
+                    fvc::flux(HUEqns[phasej].H())
+                  + ddtPhiCoeffs[phasej]
+                );
+        }
+    }
+}
+
+initZeroPtrList(dragSourcef, mesh, dimensionSet(0, 3, -1, 0, 0), "dragSourcef");
+
+forAllConstIter(multiphaseSystem::KdfTable, fluid.Kdfs(), KdfIter)
+{
+    const surfaceScalarField& Kf(*KdfIter());
+    const phasePair& pair(fluid.phasePairs()[KdfIter.key()]);
+
+    forAllConstIter(phasePair, pair, iter)
+    {
+        const phaseModel& phase = iter();
+        const phaseModel& otherPhase = iter.otherPhase();
+
+        if (partialElimination)
+        {
+            dragSourcef[phase.index()]
+                += Kf*rAfs[otherPhase.index()]*HbyASumf[phase.index()];
+
+            forAll(phases, phasei)
+            {
+                if
+                (
+                    (phasei == phase.index())
+                 || (phasei == otherPhase.index())
+                ) continue;
+
+                dragSourcef[phase.index()] -=
+                (
+                    Kf*rAfs[otherPhase.index()]
+                   *(
+                        fvc::interpolate(HUEqns[phasei].A())
+                      + fvc::interpolate(ddtUEqns[phasei].A())
+                    )
+                   *rHUfs[phase.index()]*phases[phasei].phi()
+                );
+            }
+        }
+        else
+        {
+            dragSourcef[phase.index()]
+                += Kf*rHUfs[phase.index()]*phases[otherPhase.index()].phi();
+        }
+    }
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/forcesSource.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/forcesSource.H
new file mode 100644
index 000000000..792f35611
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/forcesSource.H
@@ -0,0 +1,36 @@
+initZeroPtrList
+(
+    forcesSource, mesh, dimensionSet(1, -2, -2, 0, 0), "forcesSource"
+);
+
+// Add lift force
+// Inspired by MomentumTransferPhaseSystem::phiFfs()
+forAllConstIter(multiphaseSystem::FlTable, fluid.Fls(), FlIter)
+{
+    const volVectorField& F(*FlIter());
+    const phasePair& pair(fluid.phasePairs()[FlIter.key()]);
+
+    forcesSource[pair.phase1().index()] -= F;
+    forcesSource[pair.phase2().index()] += F;
+}
+
+// Add wall lubrication force
+// Inspired by MomentumTransferPhaseSystem::phiFfs()
+forAllConstIter(multiphaseSystem::FwTable, fluid.Fws(), FwIter)
+{
+    const volVectorField& F(*FwIter());
+    const phasePair& pair(fluid.phasePairs()[FwIter.key()]);
+
+    forcesSource[pair.phase1().index()] -= F;
+    forcesSource[pair.phase2().index()] += F;
+}
+
+// Add turbulent dispersion force
+forAllConstIter(multiphaseSystem::FtTable, fluid.Fts(), FtIter)
+{
+    const volVectorField& F(*FtIter());
+    const phasePair& pair(fluid.phasePairs()[FtIter.key()]);
+
+    forcesSource[pair.phase1().index()] -= F;
+    forcesSource[pair.phase2().index()] += F;
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/forcesSourcef.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/forcesSourcef.H
new file mode 100644
index 000000000..43059959a
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/forcesSourcef.H
@@ -0,0 +1,36 @@
+initZeroPtrList
+(
+    forcesSourcef, mesh, dimensionSet(1, 0, -2, 0, 0), "forcesSourcef"
+);
+
+// Add lift force
+// Inspired by MomentumTransferPhaseSystem::phiFfs()
+forAllConstIter(multiphaseSystem::FlfTable, fluid.Flfs(), FlfIter)
+{
+    const surfaceScalarField& Ff(*FlfIter());
+    const phasePair& pair(fluid.phasePairs()[FlfIter.key()]);
+
+    forcesSourcef[pair.phase1().index()] -= Ff;
+    forcesSourcef[pair.phase2().index()] += Ff;
+}
+
+// Add wall lubrication force
+// Inspired by MomentumTransferPhaseSystem::phiFfs()
+forAllConstIter(multiphaseSystem::FwfTable, fluid.Fwfs(), FwfIter)
+{
+    const surfaceScalarField& Ff(*FwfIter());
+    const phasePair& pair(fluid.phasePairs()[FwfIter.key()]);
+
+    forcesSourcef[pair.phase1().index()] -= Ff;
+    forcesSourcef[pair.phase2().index()] += Ff;
+}
+
+// Add turbulent dispersion force
+forAllConstIter(multiphaseSystem::FtfTable, fluid.Ftfs(), FtfIter)
+{
+    const surfaceScalarField& Ff(*FtfIter());
+    const phasePair& pair(fluid.phasePairs()[FtfIter.key()]);
+
+    forcesSourcef[pair.phase1().index()] -= Ff;
+    forcesSourcef[pair.phase2().index()] += Ff;
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/pEqn.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/pEqn.H
new file mode 100644
index 000000000..a8de62007
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/pEqn.H
@@ -0,0 +1,218 @@
+// Correct fixed-flux BCs to be consistent with the velocity BCs
+// functionality of MRF.correctBoundaryFlux(U, phi)
+forAll(fluid.movingPhases(), movingPhasei)
+{
+    phaseModel& phase = fluid.movingPhases()[movingPhasei];
+
+    FieldField<fvsPatchField, scalar> Uf
+    (
+        mesh.Sf().boundaryField() & phase.U()().boundaryField()
+    );
+
+    surfaceScalarField::Boundary& phibf = phase.phiRef().boundaryFieldRef();
+
+    forAll(mesh.boundary(), patchi)
+    {
+        if
+        (
+            isA<fixedValueFvsPatchScalarField>(phibf[patchi])
+        )
+        {
+            phibf[patchi] == Uf[patchi];
+        }
+    }
+}
+
+// Update explicit drag terms for PISO loop
+#include "pU/dragSource.H"
+#include "pU/dragSourcef.H"
+
+// Explicit part of the time derivative of the virtual mass for PISO loop
+#include "pU/vmSource.H"
+#include "pU/vmSourcef.H"
+
+// Update lift, wall lubrication and turbulent dispersion forces for PISO loop
+#include "pU/forcesSource.H"
+#include "pU/forcesSourcef.H"
+
+// Pseudo convected velocities
+forAll(phases, phasei)
+{
+    const volVectorField& UAlpha = phases[phasei].U();
+
+    HbyAs.set
+    (
+        phasei,
+        constrainHbyA
+        (
+            rHUs[phasei]*HUEqns[phasei].H(),
+            UAlpha,
+            p_rgh
+        )
+    );
+}
+
+// Predicted fluxes for each phase
+forAll(phases, phasei)
+{
+    phiHbyAs.set
+    (
+        phasei,
+        rAUfs[phasei]
+       *(
+            fvc::flux(HbyAs[phasei])
+          + rHUfs[phasei]*ddtPhiCoeffs[phasei]
+          + dragSourcef[phasei]
+          + rHUfs[phasei]*alphafs[phasei]*(g & mesh.Sf())
+           *(
+                fvc::interpolate(phases[phasei].rho()) - fvc::interpolate(rho)
+            )
+          + (1 - relaxU[phasei])/max(relaxU[phasei], small)
+           *phases[phasei].phiRef().prevIter()
+          + vmSourcef[phasei]
+          + rHUfs[phasei]*forcesSourcef[phasei]
+        )
+    );
+}
+
+// Total predicted flux
+surfaceScalarField phiHbyA
+(
+    IOobject
+    (
+        "phiHbyA",
+        runTime.timeName(),
+        mesh,
+        IOobject::NO_READ,
+        IOobject::AUTO_WRITE
+    ),
+    mesh,
+    dimensionedScalar(dimArea*dimVelocity, 0)
+);
+
+forAll(phases, phasei)
+{
+    phiHbyA += alphafs[phasei]*(phiHbyAs[phasei] + phigs[phasei]);
+}
+
+// Update the fixedFluxPressure BCs to ensure flux consistency
+{
+    surfaceScalarField::Boundary phib(phi.boundaryField());
+    phib = 0;
+    forAll(phases, phasei)
+    {
+        phaseModel& phase = phases[phasei];
+        phib += alphafs[phasei].boundaryField()*phase.phiRef().boundaryField();
+    }
+
+    setSnGrad<fixedFluxPressureFvPatchScalarField>
+    (
+        p_rgh.boundaryFieldRef(),
+        (
+            phiHbyA.boundaryField() - phib
+        )/(mesh.magSf().boundaryField()*rAUf.boundaryField())
+    );
+}
+
+// Iterate over the pressure equation to correct for non-orthogonality
+while (pimple.correctNonOrthogonal())
+{
+    // Construct the transport part of the pressure equation
+    fvScalarMatrix p_rghEqnIncomp
+    (
+        fvc::div(phiHbyA)
+      - fvm::laplacian(rAUf, p_rgh)
+    );
+
+    // Solve
+    {
+        fvScalarMatrix p_rghEqn(p_rghEqnIncomp);
+
+        if (fluid.incompressible())
+        {
+            p_rghEqn.setReference(pRefCell, getRefCellValue(p_rgh, pRefCell));
+        }
+
+        p_rghEqn.solve();
+    }
+
+    // Correct fluxes and velocities on last non-orthogonal iteration
+    if (pimple.finalNonOrthogonalIter())
+    {
+        phi = phiHbyA + p_rghEqnIncomp.flux();
+
+        surfaceScalarField mSfGradp("mSfGradp", p_rghEqnIncomp.flux()/rAUf);
+
+        forAll(phases, phasei)
+        {
+            phaseModel& phase = phases[phasei];
+
+            phase.phiRef() =
+                phiHbyAs[phasei]
+              + phigs[phasei]
+              + alpharAUfs[phasei]*mSfGradp;
+        }
+
+        // Optionally relax pressure for velocity correction
+        p_rgh.relax();
+
+        mSfGradp = p_rghEqnIncomp.flux()/rAUf;
+
+        // Momentum corrector
+        forAll(phases, phasei)
+        {
+            phaseModel& phase = phases[phasei];
+            const volScalarField& alpha = phase;
+            volVectorField& UAlpha = phase.URef();
+
+            if (faceMomentum)
+            {
+                UAlpha =
+                    fvc::reconstruct(phase.phi());
+            }
+            else
+            {
+                UAlpha =
+                    1.0
+                   /(
+                        ddtUEqns[phasei].A()
+                      + HUEqns[phasei].A()/max(relaxU[phasei], small)
+                      + dragDiag[phasei]
+                      + vmDiag[phasei]
+                    )
+                   *(
+                        HUEqns[phasei].A()*HbyAs[phasei]
+                      + ddtUEqns[phasei].H()
+                      + dragSource[phasei]
+                      + alpha*(phase.rho() - rho)*g
+                      + (1 - relaxU[phasei])/max(relaxU[phasei], small)
+                       *HUEqns[phasei].A()*UAlpha.prevIter()
+                      + vmSource[phasei]
+                      + forcesSource[phasei]
+                    )
+                  + fvc::reconstruct
+                    (
+                        phigs[phasei]
+                      + alpharAUfs[phasei]*mSfGradp
+                    );
+            }
+
+            UAlpha.correctBoundaryConditions();
+        }
+    }
+}
+
+// Update the mixture properties and static pressure
+U = fluid.U();
+p = p_rgh + rho*gh;
+
+// Account for static pressure reference
+if (p_rgh.needReference() && fluid.incompressible())
+{
+    p += dimensionedScalar
+    (
+        "p",
+        p.dimensions(),
+        pRefValue - getRefCellValue(p, pRefCell)
+    );
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/stabilizeHUEqn.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/stabilizeHUEqn.H
new file mode 100644
index 000000000..93de1d4be
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/stabilizeHUEqn.H
@@ -0,0 +1,43 @@
+forAll(phases, phasei)
+{
+    phaseModel& phase = phases[phasei];
+    const volScalarField& alpha = phase;
+    const volScalarField& rhoAlpha = phase.rho();
+    volVectorField& UAlpha = phase.URef();
+
+    // Stabilize due to zero flux
+    const dimensionedScalar residualDivU(dimensionSet(1, -3, -1, 0, 0), vSmall);
+
+    HUEqns[phasei] +=
+        fvm::Sp
+        (
+            max
+            (
+                residualDivU - fvc::div(phase.alphaRhoPhi()),
+                dimensionedScalar(dimensionSet(1, -3, -1, 0, 0), Zero)
+            ),
+            UAlpha
+        )
+      - fvc::Sp
+        (
+            max
+            (
+                residualDivU - fvc::div(phase.alphaRhoPhi()),
+                dimensionedScalar(dimensionSet(1, -3, -1, 0, 0), Zero)
+            ),
+            UAlpha
+        );
+
+    // Stabilize due to zero phase fraction
+    HUEqns[phasei] +=
+        fvm::ddt
+        (
+            max(phase.residualAlpha() - alpha, scalar(0))*rhoAlpha,
+            UAlpha
+        )
+      - fvc::ddt
+        (
+            max(phase.residualAlpha() - alpha, scalar(0))*rhoAlpha,
+            UAlpha
+        );
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmDiag.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmDiag.H
new file mode 100644
index 000000000..b209496ed
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmDiag.H
@@ -0,0 +1,16 @@
+initZeroPtrList(vmDiag, mesh, dimensionSet(1, -3, -1, 0, 0), "vmDiag");
+initZeroPtrList(vmDiagf, mesh, dimensionSet(1, -3, -1, 0, 0), "vmDiagf");
+
+forAllConstIter(multiphaseSystem::VmTable, fluid.Vms(), VmIter)
+{
+    const volScalarField& Vm(*VmIter());
+    const phasePair& pair(fluid.phasePairs()[VmIter.key()]);
+
+    forAllConstIter(phasePair, pair, iter)
+    {
+        const phaseModel& phase = iter();
+
+        vmDiag[phase.index()] += byDt(Vm);
+        vmDiagf[phase.index()] += byDt(fvc::interpolate(Vm));
+    }
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmSource.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmSource.H
new file mode 100644
index 000000000..f670aee1a
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmSource.H
@@ -0,0 +1,22 @@
+initZeroPtrList(vmSource, mesh, dimensionSet(1, -2, -2, 0, 0), "vmSource");
+
+forAllConstIter(multiphaseSystem::VmTable, fluid.Vms(), VmIter)
+{
+    const volScalarField& Vm(*VmIter());
+    const phasePair& pair(fluid.phasePairs()[VmIter.key()]);
+
+    forAllConstIter(phasePair, pair, iter)
+    {
+        const phaseModel& phase = iter();
+        const phaseModel& otherPhase = iter.otherPhase();
+
+        vmSource[phase.index()] +=
+            Vm
+           *byDt
+            (
+                phase.U()().oldTime()
+              + otherPhase.U()
+              - otherPhase.U()().oldTime()
+            );
+    }
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmSourcef.H b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmSourcef.H
new file mode 100644
index 000000000..b107f94a5
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/cipsaMultiphaseEulerFoam/pU/vmSourcef.H
@@ -0,0 +1,23 @@
+initZeroPtrList(vmSourcef, mesh, dimensionSet(0, 3, -1, 0, 0), "vmSourcef");
+
+forAllConstIter(multiphaseSystem::VmTable, fluid.Vms(), VmIter)
+{
+    const volScalarField& Vm(*VmIter());
+    const phasePair& pair(fluid.phasePairs()[VmIter.key()]);
+
+    forAllConstIter(phasePair, pair, iter)
+    {
+        const phaseModel& phase = iter();
+        const phaseModel& otherPhase = iter.otherPhase();
+
+        vmSourcef[phase.index()] +=
+            rHUfs[phase.index()]
+           *fvc::interpolate(Vm)
+           *byDt
+            (
+                phase.phi()().oldTime()
+              + otherPhase.phi()
+              - otherPhase.phi()().oldTime()
+            );
+    }
+}
diff --git a/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/Make/files b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/Make/files
index a40b522c9..ed5796496 100644
--- a/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/Make/files
+++ b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/Make/files
@@ -18,6 +18,8 @@ dragModels/IshiiZuber/IshiiZuber.C
 dragModels/AttouFerschneider/AttouFerschneider.C
 dragModels/aerosolDrag/aerosolDrag.C
 dragModels/timeScaleFilteredDrag/timeScaleFilteredDrag.C
+dragModels/IshiiZuberSparse/IshiiZuberSparse.C
+dragModels/StrubeljTiselj/StrubeljTiselj.C
 
 swarmCorrections/swarmCorrection/swarmCorrection.C
 swarmCorrections/swarmCorrection/newSwarmCorrection.C
diff --git a/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/IshiiZuberSparse/IshiiZuberSparse.C b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/IshiiZuberSparse/IshiiZuberSparse.C
new file mode 100644
index 000000000..412f482d2
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/IshiiZuberSparse/IshiiZuberSparse.C
@@ -0,0 +1,83 @@
+/*---------------------------------------------------------------------------*\
+  ==  == ====== ====   ====    |
+                    \\     ||  | Unsupported Contributions for OpenFOAM
+  ======   //   ||  || ===//   |
+  ||  ||  //    ||  // || \\   | Copyright (C) 2018-2020 OpenFOAM Foundation
+  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
+-------------------------------------------------------------------------------
+License
+    This file is a derivative work of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+\*---------------------------------------------------------------------------*/
+
+#include "IshiiZuberSparse.H"
+#include "phasePair.H"
+#include "addToRunTimeSelectionTable.H"
+
+// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //
+
+namespace Foam
+{
+namespace dragModels
+{
+    defineTypeNameAndDebug(IshiiZuberSparse, 0);
+    addToRunTimeSelectionTable(dragModel, IshiiZuberSparse, dictionary);
+}
+}
+
+
+// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //
+
+Foam::dragModels::IshiiZuberSparse::IshiiZuberSparse
+(
+    const dictionary& dict,
+    const phasePair& pair,
+    const bool registerObject
+)
+:
+    dragModel(dict, pair, registerObject)
+{}
+
+
+// * * * * * * * * * * * * * * * * Destructor  * * * * * * * * * * * * * * * //
+
+Foam::dragModels::IshiiZuberSparse::~IshiiZuberSparse()
+{}
+
+
+// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //
+
+Foam::tmp<Foam::volScalarField>
+Foam::dragModels::IshiiZuberSparse::CdRe() const
+{
+    const volScalarField Re(pair_.Re());
+    const volScalarField Eo(pair_.Eo());
+
+    const volScalarField CdRe
+    (
+        24*(1 + 0.1*pow(Re, 0.75))
+    );
+
+    const volScalarField CdReEllipse(0.6666*sqrt(Eo)*Re);
+
+    return
+        pos0(CdReEllipse - CdRe)
+       *min(CdReEllipse, Re*2.66667)
+      + neg(CdReEllipse - CdRe)*CdRe;
+}
+
+
+// ************************************************************************* //
diff --git a/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/IshiiZuberSparse/IshiiZuberSparse.H b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/IshiiZuberSparse/IshiiZuberSparse.H
new file mode 100644
index 000000000..5bc44b029
--- /dev/null
+++ b/applications/solvers/multiphase/reactingEulerFoam/interfacialModels/dragModels/IshiiZuberSparse/IshiiZuberSparse.H
@@ -0,0 +1,105 @@
+/*---------------------------------------------------------------------------*\
+  ==  == ====== ====   ====    |
+                    \\     ||  | Unsupported Contributions for OpenFOAM
+  ======   //   ||  || ===//   |
+  ||  ||  //    ||  // || \\   | Copyright (C) 2018-2020 OpenFOAM Foundation
+  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
+-------------------------------------------------------------------------------
+License
+    This file is a derivative work of OpenFOAM.
+
+    OpenFOAM is free software: you can redistribute it and/or modify it
+    under the terms of the GNU General Public License as published by
+    the Free Software Foundation, either version 3 of the License, or
+    (at your option) any later version.
+
+    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+    for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+
+Class
+    Foam::dragModels::IshiiZuberSparse
+
+Description
+    Ishii and Zuber (1979) drag model for sparse dispersed bubbly flows. Due to
+    the simplification of a sparse flow regime no correction for swarm and/or
+    viscous effects in the elliptical and cap shape regime is included. To
+    account for such effects add a swarmCorrection model or use IshiiZuber for
+    dense dispersed bubbly flows.
+
+    Reference:
+    \verbatim
+        Ishii, M., & Zuber, N. (1979).
+        Drag coefficient and relative velocity in bubbly, droplet or particulate
+        flows.
+        AIChE Journal, 25(5), 843-855.
+    \endverbatim
+
+SourceFiles
+    IshiiZuberSparse.C
+
+\*---------------------------------------------------------------------------*/
+
+#ifndef IshiiZuberSparse_H
+#define IshiiZuberSparse_H
+
+#include "dragModel.H"
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+namespace Foam
+{
+namespace dragModels
+{
+
+/*---------------------------------------------------------------------------*\
+                       Class IshiiZuberSparse Declaration
+\*---------------------------------------------------------------------------*/
+
+class IshiiZuberSparse
+:
+    public dragModel
+{
+
+public:
+
+    //- Runtime type information
+    TypeName("IshiiZuberSparse");
+
+
+    // Constructors
+
+        //- Construct from a dictionary and a phase pair
+        IshiiZuberSparse
+        (
+            const dictionary& dict,
+            const phasePair& pair,
+            const bool registerObject
+        );
+
+
+    //- Destructor
+    virtual ~IshiiZuberSparse();
+
+
+    // Member Functions
+
+        //- Drag coefficient
+        virtual tmp<volScalarField> CdRe() const;
+};
+
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+} // End namespace dragModels
+} // End namespace Foam
+
+// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
+
+#endif
+
+// ************************************************************************* //
